/*************************************************************************/
/*                                                                       */
/*                 Declarations specifiques analyseur                    */
/*                                                                       */
/*************************************************************************/
/* $Id: anal.h,v 1.921 1997/03/26 00:05:38 karim Exp $ */
typedef struct module { entree *func; char **help; } module;

entree *findentry(long n, char *beg, char *end, entree **table);
long   check_break_status(long action, GEN *x);

extern long prec;
extern GEN gnil;

extern GEN  (*gp_history_fun)(long, long, char *, char *);
extern void *foreignHandler;
extern GEN  (*foreignExprHandler)(char*);
extern char foreignExprSwitch;
extern long (*foreignAutoload)(char*, long);
extern void (*foreignFuncFree)(entree *);

/* Variables contenant la liste des fonctions PARI */
extern int     functions_tblsz;     /* taille de la table de hashcodes */
extern module  *pari_modules;       /* liste des modules de fonctions */
extern entree  **functions_hash;    /* table de hachage */
extern char    *helpmessages_basic[];
extern entree  functions_basic[];

/* Variables contenant la liste des fonctions specifiques a GP */
extern char    *helpmessages_gp[];
extern entree   functions_gp[];

/* Variables contenant la liste des vieilles fonctions PARI (jusqu'a 1.39) */
extern module  *pari_oldmodules;    /* liste des modules de fonctions */
extern entree  **funct_old_hash;    /* table de hachage */
extern char    *oldhelpmessage[], *helpmessages_oldgp[];
extern entree   oldfonctions[], functions_oldgp[];

extern char *current_function;

/* backward compatibility */
extern long compatible;
enum { NONE, WARN, OLDFUN, OLDALL };
#define new_fun_set (compatible == NONE || compatible == WARN)

/* return type for GP functions */
enum { RET_GEN, RET_INT, RET_VOID };

/* entrees */
#define EpVALENCE(ep) ((ep)->valence & 0xFF)
#define EpSTATIC 0x100
#define PARAMSHIFT 9
#define EpNPARAM(ep) ((ep)->valence >> PARAMSHIFT)
 
#define EpALIAS 102
#define EpNEW 101
#define EpUSER 100
#define EpVAR 200

#define NOT_CREATED_YET (entree *)1 /* for check_new_fun */

/* break */

enum { br_NONE, br_BREAK, br_NEXT, br_RETURN }; /* break status */

enum {
  NOACTION, DOCLEAR, DOBREAK, DONEXT, DORETURN, /* set break status */

  DOLOOP, DOFUNCTION /* what we were doing */
};

/* formatted printing
 * The files using these macros should define statically thestring.
 * E.g: static char thestring[80]
 */
#define print1(format,i)     \
  (sprintf(thestring,(format),(i)),pariputs(thestring))
 
#define print2(format,i,j)   \
  (sprintf(thestring,(format),(i),(j)),pariputs(thestring))
 
#define print3(format,i,j,k) \
  (sprintf(thestring,(format),(i),(j),(k)),pariputs(thestring))

#define print4(format,i,j,k,l) \
  (sprintf(thestring,(format),(i),(j),(k),(l)),pariputs(thestring))

#ifndef LONG_IS_64BIT
#  define VOIR_STRING1 "[&=%08lx] "
#  define VOIR_STRING2 "%08lx  "
#  define VOIR_STRING3 "  %08lx  :  "
#else
#  define VOIR_STRING1 "[&=%08x%08x] "
#  define VOIR_STRING2 "%08x%08x  "
#  define VOIR_STRING3 "  %08x%08x  :  "
#endif

#define INIT_JMPm 1
#define INIT_SIGm 2
#define INIT_JMP     (init_opts & INIT_JMPm)
#define INIT_SIG     (init_opts & INIT_SIGm)
#define INIT_JMP_on  (init_opts |= INIT_JMPm)
#define INIT_SIG_on  (init_opts |= INIT_SIGm)
#define INIT_JMP_off (init_opts &= ~INIT_JMPm)
#define INIT_SIG_off (init_opts &= ~INIT_SIGm)
