/********************************************************************/
/********************************************************************/
/**                                                                **/
/**                  BIBLIOTHEQUE  MATHEMATIQUE                    **/
/**                     (deuxieme partie)                          **/
/**                        split ---                               **/
/**                                                                **/
/**                     Copyright Babe Cool                        **/
/**                                                                **/
/********************************************************************/
/********************************************************************/
/* $Id: sumiter.c,v 1.922 1997/04/06 02:52:40 karim Exp karim $ */
#include "genpari.h"
#include "anal.h"

/********************************************************************/
/**                                                                **/
/**                        ITERATIONS                              **/
/**                                                                **/
/********************************************************************/

void
forpari(entree *ep, GEN a, GEN b, char *ch)
{
  long la,lx,i,e, av = avma;
  GEN p1;

  switch (typ(a))
  {
    case t_INT:
      la = lx = lgefint(a); if (lx<3) lx=3;
      if (!gcmp0(b)) 
        { e = (gexpo(b)>>TWOPOTBITS_IN_LONG) + 3; if (e>lx) lx=e; }
      p1=newbloc(lx); for (i=0; i<la; i++) p1[i]=a[i];
      setlg(p1,lx); p1[-1] = (long) ep->value;
      ep->value = (void*) p1; break;
    case t_REAL:
      newvalue(ep,a); break;
    default: err(typeer,"for");
  }
  p1 = (GEN) ep->value;
  while (gcmp(p1,b)<=0)
  {
    avma=av; lisseq(ch);
    if (check_break_status(DOLOOP,NULL)) break;
    gaddz(p1,gun,p1); p1 = (GEN) ep->value;
  }
  avma=av; killvalue(ep);
}

void
forstep(entree *ep, GEN a, GEN b, GEN s, char *ch)
{
  long lx,la,s1,i,e, av = avma;
  GEN p1;

  s1=gsigne(s); if (!s1) err(forer2);
  switch (typ(a))
  {
    case t_INT:
      la = lx = lgefint(a); if (lx<3) lx=3;
      if (!gcmp0(b)) 
        { e = (gexpo(b)>>TWOPOTBITS_IN_LONG) + 3; if (e>lx) lx=e; }
      switch (typ(s))
      {
        case t_REAL:
          p1=cgetr(lg(s)); affir(a,p1);
          newvalue(ep,p1); break;
        case t_INT:
          p1=newbloc(lx); for (i=0; i<la; i++) p1[i]=a[i];
          setlg(p1,lx); p1[-1]=(long)ep->value;
          ep->value=(void*)p1; break;
        default: err(typeer,"forstep");
      }
      break;
    case t_REAL:
      newvalue(ep,a); break;
    default: err(typeer,"forstep");
  }
  p1=(GEN)ep->value;
  if (s1>0)
    while (gcmp(p1,b) <= 0)
    {
      avma=av; lisseq(ch);
      if (check_break_status(DOLOOP,NULL)) break;
      gaddz(p1,s,p1); p1 = (GEN) ep->value;
    }
  else
    while (gcmp(p1,b) >= 0)
    {
      avma=av; lisseq(ch);
      if (check_break_status(DOLOOP,NULL)) break;
      gaddz(p1,s,p1); p1 = (GEN) ep->value;
    }
  avma=av; killvalue(ep);
}

void
forprime(entree *ep, GEN a, GEN b, char *ch)
{
  GEN p1;
  long av=avma,prime=0;
  byteptr p=diffptr;

  newvalue(ep,gun); p1 = (GEN)ep->value;
  while (*p && gcmpgs(a,prime) > 0) prime += *p++;
  if (!*p) err(recprimer);
  affsi(prime,p1);
  while (gcmp(p1,b)<=0)
  {
    if (!*p) err(recprimer);
    avma=av; lisseq(ch);
    if (check_break_status(DOLOOP,NULL)) break;
    addsiz(*p++,p1,p1); p1 = (GEN) ep->value;
  }
  avma=av; killvalue(ep);
}

void
fordiv0(GEN a, entree *ep,char *ch)
{
  fordiv(ep,a,ch);
}

void
fordiv(entree *ep, GEN a, char *ch)
{
  long i,av2,l,av=avma;
  GEN p1,t=divisors(a);

  newvalue(ep,a); p1=(GEN)ep->value; 
  av2=avma; l=lg(t);
  for (i=1; i<l; i++)
  {
    gaffect((GEN)t[i],p1); lisseq(ch);
    if (check_break_status(DOLOOP,NULL)) break;
    p1 = (GEN) ep->value; avma=av2;
  }
  avma=av; killvalue(ep);
}

void
forvec(entree *ep, GEN x, char *ch)
{
  GEN p1,y,a,b,c,yinit;
  long av=avma,av1,tx=typ(x),ty,n,e,la,lx,i,j;

  if (!is_vec_t(tx)) err(talker,"not a vector in forvec");
  n=lg(x)-1; if (!n) { lisseq(ch); return; }

  y=cgetg(n+1,t_VEC);
  for (i=1; i<=n; i++)
  {
    c=(GEN)x[i]; ty=typ(c);
    if (! is_vec_t(ty) || lg(c)!=3)
      err(talker,"not a vector of two-component vectors in forvec");
    a=(GEN)c[1]; b=(GEN)c[2];
    if (gcmp(a,b)>0) { avma=av; return; }
    if (typ(a)!=t_INT) p1=a;
    else
    {
      la=lx=lgefint(a); if (lx<3) lx=3;
      if (!gcmp0(b)) { e=(gexpo(b)>>TWOPOTBITS_IN_LONG)+3; if (e>lx) lx=e; }
      p1=cgeti(lx); for (j=1; j<la; j++) p1[j]=a[j];
    }
    y[i]=(long)p1;
  }
  yinit = y; changevalue(ep,y); av1=avma; y = (GEN)ep->value;
  for(;;)
  {
    avma=av1; lisseq(ch); i=n+1;
    if (check_break_status(DOLOOP,NULL)) i = 1; /* we exit now */
    if ((GEN) ep->value != y) y = (GEN) ep->value;
    do
    {
      i--;
      if (!i) { killvalue(ep); avma = av; return; }
      if (i<n) gaffect((GEN)yinit[i+1],(GEN)y[i+1]);
      gaddgsz((GEN)y[i],1,(GEN)y[i]);
    }
    while (gcmp((GEN)y[i],gmael(x,i,2)) > 0);
  }
}

/********************************************************************/
/**                                                                **/
/**       SOMMES,PRODUITS,VECTEURS,MATRICES ET RECURRENCES         **/
/**                                                                **/
/********************************************************************/

GEN
direuler(entree *ep, GEN a, GEN b, char *ch)
{
  GEN p1,y,y1,s,z,polnum,polden,c0;
  long av,av1,tetpil,limite=(avma+bot)>>1,prime=0,q,n,i,j,k,k1,tx,lx;
  byteptr p=diffptr;

  if (gcmpgs(b,2)<0) { y=cgetg(2,t_VEC); y[1]=un; return y; }
  av1=avma; n=itos(gmin(b,stoi(MAXHALFULONG-1))); b=stoi(n);
  y1=cgetg(n+1,t_VEC); av=avma;
  y=cgetg(n+1,t_VEC); y[1]=un; for (i=2; i<=n; i++) y[i]=zero;
  newvalue(ep,gun); p1 = (GEN) ep->value;
  while ( *p && gcmpgs(a,prime)>0 ) prime += *p++;
  if (!*p) err(recprimer);
  affsi(prime,p1); tetpil=avma;
  while (gcmp(p1,b)<=0)
  {
    if (!*p) err(recprimer);
    if (avma<limite)
    {
      if (DEBUGMEM>1) fprintferr("Collecting garbage in `direuler'\n");
      tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
    }
    z=lisexpr(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in direuler");
    polnum=numer(z); polden=denom(z);
    tx = typ(polnum);
    if (is_scalar_t(tx))
    {
      if (!gcmp1(polnum))
	err(talker,"constant term not equal to 1 in direuler");
    }
    else
    {
      if (tx != t_POL) err(typeer,"direuler");
      c0=truecoeff(polnum,0);
      if (!gcmp1(c0)) err(talker,"constant term not equal to 1 in direuler");
      for (i=1; i<=n; i++) y1[i]=y[i];
      prime=itos(p1); q=prime; j=1; lx=lgef(polnum)-3;
      while (q<=n && j<=lx)
      {
	c0=(GEN)polnum[j+2];
	if (!gcmp0(c0))
	  for (k=1,k1=q; k1<=n; k1+=q,k++)
	    y[k1] = (long) gadd( (GEN)y[k1], gmul(c0,(GEN)y1[k]) );
	q*=prime; j++;
      }
    }

    tx=typ(polden);
    if (is_scalar_t(tx))
    {
      if (!gcmp1(polden))
	err(talker,"constant term not equal to 1 in direuler");
    }
    else
    {
      if (tx != t_POL) err(typeer,"direuler");
      c0=truecoeff(polden,0);
      if (!gcmp1(c0)) err(talker,"constant term not equal to 1 in direuler");
      prime=itos(p1); lx=lgef(polden)-3;
      for (i=prime; i<=n; i+=prime)
      {
	s=gzero; k=i; j=1;
	while (!(k%prime) && j<=lx)
	{
	  c0=(GEN)polden[j+2]; k/=prime; j++;
	  if (!gcmp0(c0)) s=gadd(s,gmul(c0,(GEN)y[k]));
	 }
	y[i]=lsub((GEN)y[i],s);
      }
    }
    addsiz(*p++,p1,p1);
  }
  killvalue(ep); tetpil=avma;
  return gerepile(av1,tetpil,gcopy(y));
}

GEN
somme(entree *ep, GEN a, GEN b, char *ch, GEN x)
{
  GEN y,z,p1;
  long av = avma,tetpil,limite=(avma+bot)>>1;

  newvalue(ep,gun); p1 = (GEN)ep->value; gaffect(a, p1);
  y = x; tetpil = avma;
  if (gcmp(a,b)>0)
  {
    gaddgsz(p1,-1,p1);
    while (gcmp(p1,b)>0)
    {
      if (avma<limite)
      {
	if (DEBUGMEM>1) fprintferr("Collecting garbage in `somme' [1]\n");
	tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
      }
      z=gneg(lisexpr(ch));
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in sum");
      tetpil=avma; y=gadd(y,z); gaddgsz(p1,-1,p1);
    }
  }
  else
    do
    {
      if (avma<limite)
      {
	if (DEBUGMEM>1) fprintferr("Collecting garbage in `somme' [2]\n");
	tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
      }
      z=lisexpr(ch);
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in sum");
      tetpil=avma; y=gadd(y,z); gaddgsz(p1,1,p1);
    }
    while (gcmp(p1,b)<=0);
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

GEN
suminf(entree *ep, GEN a, char *ch, long prec)
{
  GEN y,z,p1;
  long av=avma,tetpil,limite=(bot+avma)>>1,fl,G;

  newvalue(ep,gun); p1 = (GEN)ep->value; gaffect(a, p1);
  y=gun; fl=0; G = ((prec-2)<<TWOPOTBITS_IN_LONG)+5;
  do
  {
    if (avma < limite) { tetpil = avma; y=gerepile(av,tetpil,gcopy(y)); }
    z=lisexpr(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in sum");
    y=gadd(y,z); gaddgsz(p1,1,p1);
    if (gcmp0(z) || gexpo(z) <= gexpo(y)-G) fl++; else fl=0;
  }
  while (fl<3);
  killvalue(ep); tetpil=avma;
  return gerepile(av,tetpil,gsubgs(y,1));
}

GEN
produit(entree *ep, GEN a, GEN b, char *ch, GEN x)
{
  GEN   y,z,p1;
  long  av=avma,tetpil,limite=(av+bot)/2;

  newvalue(ep,gun); p1 = (GEN)ep->value; gaffect(a,p1);
  y = x;
  tetpil = avma;
  if (gcmp(a,b)>0)
  {
    gaddgsz(p1,-1,p1);
    while (gcmp(p1,b)>0)
    {
      if (avma<limite)
      {
	if (DEBUGMEM>1) fprintferr("Collecting garbage in `produit' [1]\n");
	tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
      }
      z=lisexpr(ch);
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in prod");
      tetpil=avma; y=gdiv(y,z);
      gaddgsz(p1,-1,p1);
    }
  }
  else
    do
    {
      if (avma<limite)
      {
	if (DEBUGMEM>1) fprintferr("Collecting garbage in `produit' [2]\n");
	tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
      }
      z=lisexpr(ch);
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in prod");
      tetpil=avma; y=gmul(y,z);
      gaddgsz(p1,1,p1);
    }
    while (gcmp(p1,b)<=0);
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

GEN
prodinf0(entree *ep, GEN a, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return prodinf(ep,a,ch,prec);
    case 1: return prodinf1(ep,a,ch,prec);
  }
  err(flagerr);
  return NULL; /* not reached */
}

GEN
prodinf(entree *ep, GEN a, char *ch, long prec)
{
  GEN y,z,p1;
  long av=avma,tetpil,limite=(av+bot)>>1,G,fl=0;

  newvalue(ep, gun); p1=(GEN)ep->value; gaffect(a,p1);
  affsr(1,y=cgetr(prec)); G = ((prec-2)<<TWOPOTBITS_IN_LONG)+5;
  do
  {
    if (avma<limite)
    {
      if (DEBUGMEM>1) fprintferr("Collecting garbage in `prodinf'\n");
      tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
    }
    z=lisexpr(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in prod");
    y=gmul(y,z);
    if (DEBUGLEVEL>4) { outerr(p1); outerr(z); outerr(y); }
    gaddgsz(p1,1,p1);
    if (gexpo(gsubgs(z,1)) <= -G) fl++; else fl=0; 
  }
  while (fl<3);
  killvalue(ep); tetpil = avma;
  return gerepile(av,tetpil,gcopy(y));
}

GEN
prodinf1(entree *ep, GEN a, char *ch, long prec)
{
  GEN y,z,p1,p2;
  long av=avma,tetpil,limite=(av+bot)>>1,G,fl=0;

  newvalue(ep,gun); p1=(GEN)ep->value; gaffect(a,p1);
  affsr(1,y=cgetr(prec)); G = ((prec-2)<<TWOPOTBITS_IN_LONG)+5;
  do
  {
    if (avma<limite)
    {
      if (DEBUGMEM>1) fprintferr("Collecting garbage in `prodinf1'\n");
      tetpil=avma; y=gerepile(av,tetpil,gcopy(y));
    }
    p2=lisexpr(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in prod");
    z=gadd(gun,p2); y=gmul(y,z);
    if (DEBUGLEVEL>4) { outerr(p1); outerr(z); outerr(y); }
    gaddgsz(p1,1,p1);
    if (gcmp0(z) || gexpo(p2) <= -G) fl++; else fl=0;
  }
  while (fl<3);
  killvalue(ep); tetpil = avma;
  return gerepile(av,tetpil,gcopy(y));
}

GEN
prodeuler(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  GEN y,z,p1;
  long av=avma,tetpil,prime=0;
  byteptr p=diffptr;

  newvalue(ep,gun); p1 = (GEN)ep->value;
  while (*p && gcmpgs(a,prime)>0) prime += *p++;
  if (!*p) err(recprimer);
  affsi(prime,p1); affsr(1,y=cgetr(prec));
  if (gcmp(p1,b)>0)
  {
    if (!gcmp1(gsub(a,b))) err(recer1);
    tetpil=avma; y=gcopy(y);
  }
  else
    do
    {
      if (!*p) err(recprimer);
      z=lisexpr(ch);
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in prodeuler");
      tetpil=avma; y=gmul(y,z);
      addsiz(*p++,p1,p1);
    }
    while (gcmp(p1,b)<=0);
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

GEN
vector0(GEN nmax, entree *ep, char *ch)
{
  return vecteur(ep,nmax,ch);
}

GEN
vecteur(entree *ep, GEN nmax, char *ch)
{
  GEN y,p1,t;
  long i,m;

  if (typ(nmax)!=t_INT || signe(nmax)<0) err(vecer1);
  if (gcmpgs(nmax,LGBITS)>=0)
    err(talker,"too many components in vector");
  m=itos(nmax); y=cgetg(m+1,t_VEC);
  newvalue(ep,gun); p1 = (GEN)ep->value;
  for (i=1; i<=m; i++)
  {
    p1[2]=i; t=lisseq(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in vector");
    y[i] = isonstack(t) ? (long)t : lcopy(t);
  }
  killvalue(ep); return y;
}

/* etant donne un nombre nmax de composantes et une chaine ch representant
   un vecteur, sort ce vecteur. */
GEN
makevec(GEN nmax, char *ch)
{
  GEN y,t;
  long i,m;
  char *newch, *tmp = xmalloc(1 + strlen(ch));
  
  if (typ(nmax)!=t_INT || signe(nmax)<0) err(vecer1);
  if (gcmpgs(nmax,LGBITS)>=0)
    err(talker,"too many components in makevec");
  m=itos(nmax); y=cgetg(m+1,t_VEC);
  if (!m) return y; /* on ne verifie pas que le vecteur est vide, on devrait */
  strcpy(tmp,ch); filtre(tmp); ch=tmp;
  while (*ch && *ch != '[') ch++;
  if (*ch==0) err(talker,"vector of incorrect length in makevec");
  ch++; /* skip '[' */
  for (i=1; i<=m; i++)
  {
    t=lisseq0intern(ch,0,&newch); ch=newch;
    if (DEBUGLEVEL >= 2 && i%10==0)
      { fprintferr(" %ld",i); flusherr(); }
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in vector");
    y[i] = isonstack(t) ? (long)t : lcopy(t);
    if (*ch != ',')
    {
      if (*ch != ']') err(talker,"incorrect character in makevec");
      if (i < m) err(talker,"vector of incorrect length in makevec");
    }
    else ch++;
  }
  if (DEBUGLEVEL>=2) { fprintferr("\n"); flusherr(); }
  free(tmp); return y;
}

/* etant donne un nombre nlig de lignes, ncol de colonnes et une chaine ch
   representant une matrice, sort cette matrice. */
GEN
makemat(GEN nlig, GEN ncol, char *ch)
{
  GEN y,t;
  long i,j,m,n;
  char *newch;
  char *tmp = xmalloc(1 + strlen(ch));
  
  if (typ(ncol)!=t_INT || signe(ncol)<0 || typ(nlig)!=t_INT || signe(nlig)<0)
    err(vecer1);
  if (gcmpgs(ncol,LGBITS)>=0 || gcmpgs(nlig,LGBITS)>=0)
    err(talker,"too many components in makemat");
  n=itos(ncol); y=cgetg(n+1,t_MAT);
  if (!n) return y; /* on ne verifie pas que la matrice est vide, on devrait */
  m=itos(nlig);
  for (j=1; j<=n; j++) y[j]=lgetg(m+1,t_COL);
  if (!m) return y; /* on ne verifie pas que la matrice est vide, on devrait */
  strcpy(tmp,ch); filtre(tmp); ch=tmp;
  while ((*ch) && (*ch) != '[') ch++;
  if (*ch==0) err(talker,"vector of incorrect length in makemat");
  ch++;
  for (i=1; i<=m; i++)
  {
    for (j=1; j<=n; j++)
    {
      t=lisseq0intern(ch,0,&newch); ch=newch;
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in makemat");
      coeff(y,i,j) = isonstack(t) ? (long)t : lcopy(t);
      if (*ch != ',')
      {
	if (*ch != ';')
	{
	  if (*ch != ']') err(talker,"incorrect character in makemat");
	  if (j < n) err(talker,"incorrect number of rows in makemat");
	  if (i < m) err(talker,"incorrect number of columns in makemat");
	}
	else
	{
	  if (j < n) err(talker,"incorrect number of rows in makemat");
	  ch++;
	}
      }
      else ch++;
    }
  }
  free(tmp); return y;
}

/* FONCTIONS A METTRE DANS GP.C, y compris leur aide (pour l'instant
   dans helpmessages.c, et leur appel, pour l'instant dans anal.c */

#define GET_SEP_SIZE 128
char*
myget_sep(char *t)
{
  static char s[GET_SEP_SIZE];
  int i=0, I=GET_SEP_SIZE-1;
  char c;
  
  while (i<I)
  {
    c = s[i++] = *t++;
    if (!*t || (*t==')') ) break;
  }
  s[i]=0; return s;
}
#undef GET_SEP_SIZE

/* etant donne un nombre de composantes nmax et un NOM DE FICHIER s lequel
   contient un vecteur, sort ce vecteur. */


GEN
readvec(GEN nmax, char *s)
{
  char ch[3000000]; /* evidemment idiot, voir ci-dessous, mais c'est pour
		       mes essais. */
  FILE *fc;
  long n;

  s=myget_sep(s);
  fc=fopen(s,"r"); if (!fc) err(talker,"file does not exist in readvec");
      /* plutot un switchin_byname ? */
  n=fscanf(fc,"%3000000c",ch);
      /* peux tu modifier ca pour que ch soit le gpbuffer habituel,
	 dont la taille a ete donnee suffisante au depart de gp ? */
  fclose(fc);
  return makevec(nmax,ch);
}

/* etant donne un nombre de lignes nlig, un nombre de colonnes ncol et un
   NOM DE FICHIER s lequel contient une matrice, sort cette matrice. */
GEN
readmat(GEN nlig, GEN ncol, char *s)
{
  char ch[3000000]; /* evidemment idiot, voir ci-dessous, mais c'est pour
		       mes essais. */
  FILE *fc;

  s=myget_sep(s);
  fc=fopen(s,"r"); if (!fc) err(talker,"file does not exist in readmat");
      /* plutot un switchin_byname ? */
  fscanf(fc,"%s",ch);
      /* peux tu modifier ca pour que ch soit le gpbuffer habituel,
	 dont la taille a ete donnee suffisante au depart de gp ? */
  fclose(fc);
  return makemat(nlig,ncol,ch);
}

GEN
vvector0(GEN nmax, entree *ep, char *ch)
{
  return vvecteur(ep,nmax,ch);
}

GEN
vvecteur(entree *ep, GEN nmax, char *ch)
{
  GEN y=vecteur(ep,nmax,ch);
  settyp(y,t_COL); return y;
}

GEN
matrice0(GEN nlig, GEN ncol,entree *ep1, entree *ep2, char *ch)
{
  return matrice(ep1,ep2,nlig,ncol,ch);
}

GEN
matrice(entree *ep1, entree *ep2, GEN nlig, GEN ncol, char *ch)
{
  GEN y,z,t,p1,p2;
  long i,j,m,n,s;

  s=signe(ncol); if (typ(ncol)!=t_INT || s<0) err(mater1);
  if (!s) return cgetg(1,t_MAT);
  s=signe(nlig); if (typ(nlig)!=t_INT || s<0) err(mater1);
  if (gcmpgs(nlig,LGBITS)>=0)
    err(talker,"too many rows in matrix");
  if (gcmpgs(ncol,LGBITS)>=0)
    err(talker,"too many columns in matrix");
  n=itos(nlig); m=itos(ncol);
  if (!s)
  { 
    y=cgetg(m+1,t_MAT);
    for (i=1; i<=m; i++) y[i]=lgetg(1,t_COL);
    return y;
  }
  newvalue(ep1,gun); p1 = (GEN)ep1->value;
  newvalue(ep2,gun); p2 = (GEN)ep2->value;
  y=cgetg(m+1,t_MAT);
  for (i=1; i<=m; i++)
  {
    p2[2]=i; z=cgetg(n+1,t_COL); y[i]=(long)z;
    for (j=1; j<=n; j++)
    {
      p1[2]=j; t=lisseq(ch);
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in matrix");
      z[j] = isonstack(t) ? (long)t : lcopy(t);
    }
  }
  killvalue(ep1); killvalue(ep2); return y;
}

GEN
divsum0(GEN num, entree *ep, char *ch)
{
  return divsomme(ep,num,ch);
}

GEN
divsomme(entree *ep, GEN num, char *ch)
{
  GEN y,z,p1;
  long av=avma,tetpil,d,n,d2;

  newvalue(ep, gun); p1 = (GEN)ep->value;
  n=itos(num); /* provisoire */
  tetpil=av=avma; y=gzero;
  for (d = d2 = 1; d2 < n; d++, d2 += d+d-1)
    if (!(n%d))
    {
      p1[2]=d; y=gadd(y, lisexpr(ch));
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in divsum");
      p1[2]=n/d; z = lisexpr(ch);
      tetpil=avma; y=gadd(y,z);
    }
  if (d2 == n)
  {
    p1[2]=d; z = lisexpr(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in divsum");
    tetpil=avma; y=gadd(y,z);
  }
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

/********************************************************************/
/**                                                                **/
/**                    SOMMATION DE SERIES                         **/
/**                                                                **/
/********************************************************************/

GEN
sumalt0(entree *ep, GEN a, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return sumalt(ep,a,ch,prec);
    case 1: return sumalt2(ep,a,ch,prec);
    default: err(flagerr);
  }
  return NULL; /* not reached */
}

GEN
sumpos0(entree *ep, GEN a, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return sumpos(ep,a,ch,prec);
    case 1: return sumpos2(ep,a,ch,prec);
    default: err(flagerr);
  }
  return NULL; /* not reached */
}

GEN
sumalt(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,N;
  GEN q1,s,az,c,x,e1,d;

  newvalue(ep,gun); q1=(GEN)ep->value; gaffect(a,q1);
  av=avma; affsr(1,cgetr(prec));
  e1=addsr(3,gsqrt(stoi(8),prec));
  N=(long)(0.4*(((prec-2)<<TWOPOTBITS_IN_LONG)+7));
  d=gpuigs(e1,N); d=shiftr(addrr(d,divsr(1,d)),-1);
  az=negi(gun); c=d; s=gzero;
  for (k=0; k<N; k++)
  {
    x=lisexpr(ch);
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in divsum");
    c=gadd(az,c); if (DEBUGLEVEL>4) outerr(c);
    s=gadd(s,gmul(x,c));
    az=divii(mulii(mulss(N-k,N+k),shifti(az,1)),mulss(k+1,k+k+1));
    if (k<N-1) { a=gadd(gun,a); gaffect(a,q1); }
  }
  tetpil=avma; killvalue(ep);
  return gerepile(av,tetpil,gdiv(s,d));
}

GEN
sumalt2(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,N;
  GEN q1,s,dn,pol;

  newvalue(ep,gun); q1=(GEN)ep->value; gaffect(a,q1);
  av=avma;
  N=(long)(0.31*(((prec-2)<<TWOPOTBITS_IN_LONG)+5));
  s=gzero; pol=polzagreel(N,N>>1,prec+1); dn=gsubst(pol,0,gun);
  pol[2]=lsub((GEN)pol[2],dn); pol=gdiv(pol,gsub(polx[0],gun));
  N=lgef(pol)-2;
  for (k=0; k<N; k++)
  {
    s=gadd(s,gmul(lisexpr(ch),(GEN)pol[k+2]));
    if (check_break_status(DOLOOP,NULL))
      err(talker,"break not allowed in divsum");
    if (k<N-1) { a=gadd(gun,a); gaffect(a,q1); }
  }
  tetpil=avma; killvalue(ep);
  return gerepile(av,tetpil,gdiv(s,dn));
}

GEN
sumpos(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,kk,N,G;
  GEN p1,r,q1,unreel,s,az,c,x,e1,d, *stock;

  av=avma; a=gsubgs(a,1); affsr(1,unreel=cgetr(prec));
  e1=addsr(3,gsqrt(stoi(8),prec));
  N=(long)(0.4*(((prec-2)<<TWOPOTBITS_IN_LONG)+7));
  stock=(GEN*)cgeti(N+1); for (k=1; k<=N; k++) stock[k]=NULL;
  d=gpuigs(e1,N); d=shiftr(addrr(d,divsr(1,d)),-1);
  az=negi(gun); c=d; s=gzero;
  p1=cgeti(prec+2); p1[1]=evalsigne(1)+evallgefint(2+prec);
  newvalue(ep,p1); q1=(GEN)ep->value; G = ((prec-2)<<TWOPOTBITS_IN_LONG) + 5;
  for (k=0; k<N; k++)
  {
    if (odd(k) && stock[k]) x=stock[k];
    else
    {
      x=gzero; r=stoi(2*k+2); kk=0;
      do
      {
	gaddz(r,a,q1); p1=gmul2n(gmul(unreel,lisexpr(ch)),kk);
	if (check_break_status(DOLOOP,NULL))
	  err(talker,"break not allowed in sumpos");
	x=gadd(x,p1); r=shifti(r,1); kk++;
      }
      while (kk<=1 || gexpo(p1) >= -G);
      if (2*k<N) stock[2*k+1]=x;
      r=stoi(k+1); gaddz(r,a,q1);
      x=gadd(gmul(unreel,lisexpr(ch)),gmul2n(x,1));
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in sumpos");
    }
    c=gadd(az,c); if (DEBUGLEVEL>4) outerr(c);
    s = odd(k)? gsub(s,gmul(x,c)): gadd(s,gmul(x,c));
    az = divii(mulii(mulss(N-k,N+k),shifti(az,1)),mulss(k+1,k+k+1));
  }
  tetpil=avma; killvalue(ep);
  return gerepile(av,tetpil,gdiv(s,d));
}

GEN
sumpos2(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,kk,G,N;
  GEN p1,r,q1,unreel,s,pol,dn,x, *stock;

  av=avma; a=gsubgs(a,1); affsr(1,unreel=cgetr(prec));
  N=(long)(0.31*(((prec-2)<<TWOPOTBITS_IN_LONG)+5));
  stock=(GEN*)cgeti(N+1); for (k=0; k<N; k++) stock[k+1]=NULL;
  p1=cgeti(prec+1); p1[1]=evalsigne(1)+evallgefint(1+prec);
  newvalue(ep,p1); q1=(GEN)ep->value; G = ((prec-2)<<TWOPOTBITS_IN_LONG) + 5;
  for (k=0; k<N; k++)
  {
    if (!odd(k) || !stock[k+1])
    {
      x=gzero; r=stoi(2*k+2); kk=0;
      do
      {
	gaddz(r,a,q1); p1=gmul2n(gmul(unreel,lisexpr(ch)),kk);
	if (check_break_status(DOLOOP,NULL))
	  err(talker,"break not allowed in divsum");
	x=gadd(x,p1); r=shifti(r,1); kk++;
      }
      while (kk<=1 || gexpo(p1) >= -G);
      if (2*k+1<N) stock[2*k+2]=x;
      r=stoi(k+1); gaddz(r,a,q1);
      stock[k+1] = gadd(gmul(unreel,lisexpr(ch)),gmul2n(x,1));
      if (check_break_status(DOLOOP,NULL))
	err(talker,"break not allowed in divsum");
    }
  }
  killvalue(ep);
  s=gzero; pol=polzagreel(N,N>>1,prec+1); dn=gsubst(pol,0,gun);
  pol[2]=lsub((GEN)pol[2],dn); pol=gdiv(pol,gsub(gun,polx[0]));
  for (k=0; k<=lgef(pol)-3; k++)
  {
    if (odd(k))
      s = gadd(s,gmul((GEN)pol[k+2],stock[k+1]));
    else
      s = gsub(s,gmul((GEN)pol[k+2],stock[k+1]));
  }
  tetpil=avma; return gerepile(av,tetpil,gdiv(s,dn));
}
